use std::path::PathBuf;

xflags::xflags! {
    src "./src/flags.rs"

    cmd xtask {
        cmd shader-compile {
            optional -S, --source source: PathBuf
        }

        cmd shader-test {
            optional -S, --source source: PathBuf
        }
    }
}
// generated start
// The following code is generated by `xflags` macro.
// Run `env UPDATE_XFLAGS=1 cargo build` to regenerate.
#[derive(Debug)]
pub struct Xtask {
    pub subcommand: XtaskCmd,
}

#[derive(Debug)]
pub enum XtaskCmd {
    ShaderCompile(ShaderCompile),
    ShaderTest(ShaderTest),
}

#[derive(Debug)]
pub struct ShaderCompile {
    pub source: Option<PathBuf>,
}

#[derive(Debug)]
pub struct ShaderTest {
    pub source: Option<PathBuf>,
}

impl Xtask {
    #[allow(dead_code)]
    pub fn from_env_or_exit() -> Self {
        Self::from_env_or_exit_()
    }

    #[allow(dead_code)]
    pub fn from_env() -> xflags::Result<Self> {
        Self::from_env_()
    }

    #[allow(dead_code)]
    pub fn from_vec(args: Vec<std::ffi::OsString>) -> xflags::Result<Self> {
        Self::from_vec_(args)
    }
}
// generated end
