mod flags;
mod shader_compile;
mod shader_test;
mod slang_build;

use std::path::PathBuf;
use xshell::{Shell};
use crate::flags::XtaskCmd;

fn main() -> anyhow::Result<()> {
    let project_root = PathBuf::from(env!("CARGO_MANIFEST_DIR")).join("../..");

    let sh = Shell::new()?;
    sh.change_dir(project_root);

    let flags = flags::Xtask::from_env_or_exit();
    match flags.subcommand {
        XtaskCmd::ShaderCompile(cmd) => cmd.run(&sh),
        XtaskCmd::ShaderTest(cmd) => cmd.run(&sh),
    }
}
