use crate::flags;
use crate::slang_build::SlangBuild;
use xshell::Shell;

impl flags::ShaderCompile {
    pub(crate) fn run(&self, sh: &Shell) -> anyhow::Result<()> {
        let targets = ["slangc", "slang-glslang"];
        let build_path = SlangBuild::new(self.source.as_ref()).build_targets(&sh, &targets)?;
        let slangc_path = format!("{}/Release/bin/slangc", build_path.display());

        sh.create_dir("target/xtask/shader")?;
        sh.cmd(&slangc_path)
            .args(["-target", "spirv"])
            .args(["-o", "target/xtask/shader/hello-world.spv"])
            .arg("shader/hello-world.slang")
            .run()?;
        Ok(())
    }
}
