use crate::flags::ShaderTest;
use crate::slang_build::SlangBuild;
use xshell::Shell;

impl ShaderTest {
    pub(crate) fn run(self, sh: &Shell) -> anyhow::Result<()> {
        // Pending resolution of https://github.com/shader-slang/slang/issues/5979
        /*
        sh.cmd(format!("{}/Release/bin/slang-test", build_dir.display()))
            .args(["-category", "compute"])
            .args(["-test-dir", "shader-tests"])
            .run()?;
        Ok(())
         */

        let targets = ["slang-test"];
        let build_dir = SlangBuild::new(self.source.as_ref()).build_targets(&sh, &targets)?;
        let build_dir = build_dir.to_str().unwrap();

        // slang-test currently relies on a folder named `tests/` in the current directory
        sh.cmd("cp")
            .arg("-r")
            .arg("shader-tests")
            .arg(format!("{build_dir}/tests"))
            .run()?;

        let _dir_guard = sh.push_dir(&build_dir);
        sh.cmd(format!("Release/bin/slang-test"))
            .args(["-category", "compute"])
            .run()?;

        Ok(())
    }
}
